<?php
header("Content-Type: text/html;charset=utf-8");

class cls_Multiprecio {

	private $db_nombre = "cliente";
	private $db_nombrevista = "cliente";
	private $db_filas = "*";
	private $multiprecio_id = 0;
	private $producto_id = 0;
	private $nombre = "";
	private $precio = 0;
	
	public function __construct(){
		$this->db_filas = "multiprecio_id, producto_id, nombre, precio, usuario_modificacion, fecha_creacion, fecha_modificacion, activo";
	}

	static public function Indice($codigo){
		$current = new cls_Multiprecio();
		$conn = new cls_Conexion();
		$filtro = "multiprecio_id = ?";
		$values = array();
		array_push($values, $codigo );
		$lista = $conn->buscar_datos($current->db_nombrevista, $current->db_filas, $filtro, $values, "");
		$current->db_mensaje = $conn->getMensaje();
		for ($indice=0; $indice<count($lista); $indice++){
			$current->multiprecio_id = $lista[$indice]["multiprecio_id"];
			$current->producto_id = $lista[$indice]["producto_id"];
			$current->nombre = $lista[$indice]["nombre"];
			$current->precio = $lista[$indice]["precio"];
		}
		return $current;
	}

	public function get_multiprecio_id() { return $this->multiprecio_id; }
	public function get_producto_id() { return $this->producto_id; }
	public function get_nombre() { return $this->nombre; }
	public function get_precio() { return $this->precio; }
	
	public function set_multiprecio_id($multiprecio_id){ $this->multiprecio_id = $multiprecio_id; }
	public function set_producto_id($producto_id){ $this->producto_id = $producto_id; }
	public function set_nombre($nombre){ $this->nombre = $nombre; }
	public function set_precio($precio){ $this->precio = $precio; }
	
	public function registrar( ){
		$conn = new cls_Conexion();
		$respuesta = false;
		$values = array();
		if ( $this->multiprecio_id == 0 ){ // REGISTER
			array_push($values, $this->producto_id);
			array_push($values, $this->nombre);
			array_push($values, $this->precio);
			$respuesta = $conn->nuevo_registro($this->db_nombretabla, $values);
			$this->db_mensaje = $conn->GetMensaje();
			if ( $respuesta ){
				$this->multiprecio_id = $conn->getlastId();
			}
		} else { // UPDATE
			array_push($values, $this->producto_id);
			array_push($values, $this->nombre);
			array_push($values, $this->precio);
			array_push($values, $this->multiprecio_id);
			$respuesta = $conn->editar_registro($this->db_nombretabla, $values);
			$this->db_mensaje = $conn->GetMensaje();
		}
		return $respuesta;
	}
	
	public function importar( ){
		$conn = new cls_Conexion();
		$respuesta = false;
		$values = array();
			array_push($values, $this->producto_id);
			array_push($values, $this->nombre);
			array_push($values, $this->precio);
		if ($this->multiprecio_id > 0){
			array_push($values, $this->multiprecio_id );
		} else {
			array_push($values, NULL );
		}
		$respuesta = $conn->importar_registro($this->db_nombretabla, $values);
		$this->db_mensaje = $conn->GetMensaje();
		if ( $respuesta ){
			$this->multiprecio_id = $conn->getlastId();
		};
		return $respuesta;
	}

	public function eliminar(){
		$conn = new cls_Conexion();
		$respuesta = false;
		$values = array();
		if ($this->multiprecio_id > 0){ // DELETE
			array_push($values, $this->multiprecio_id );
			$respuesta = $conn->eliminar_registro($this->db_nombretabla, $values);
			$this->db_mensaje = $conn->GetMensaje();
		} else {
			$this->db_mensaje = "No se puede realizar este proceso";
		}
		return $respuesta;
	}
}

class cls_Group_Multiprecio {

	protected $db_mensaje = "";
	protected $db_nombre_tabla = "multiproceso";
	protected $db_nombres_columnas = "*";
	protected $db_filtro = "1";
	protected $db_agrupar = "";
	protected $db_orden_columna = "nombre";
	protected $db_orden_direccion = "ASC";
	protected $db_cantidad = 0;
	protected $db_filtro_datos = array();
	protected $db_filas = array();
	
	public function __construct(){
		$this->db_nombres_columnas = "multiprecio_id, producto_id, nombre, precio, usuario_modificacion, fecha_creacion, fecha_modificacion, activo";
		$this->db_orden_columna = "nombre";
	}

	static public function Buscar($buscar="", $ordendireccion="ASC", $ordencolumna="nombre", $agrupar=""){
		$conn = new cls_Conexion();
		$current = new cls_Group_Multiprecio();
		$buscar = "%".$buscar."%";
		$current->db_filtro = "nombre LIKE ? AND activo = true";
		$current->db_orden_columna = $ordencolumna;
		$current->db_orden_direccion = $ordendireccion;
		$current->db_agrupar = $agrupar;
		array_push($current->db_filtro_datos, $buscar );
		$current->db_cantidad = $conn->contar_filas( $current->db_nombre_tabla, $current->db_filtro, $current->db_filtro_datos, $current->db_agrupar );
		$current->db_mensaje = $conn->getMensaje();
		return $current;
	}
	public function cargar_datos( $offset, $cantidad ){
		$conn = new cls_Conexion();
		$this->db_filas = $conn->listar_filas( $this->db_nombre_tabla, $this->db_nombres_columnas, $this->db_orden_columna, $this->db_orden_direccion, $this->db_filtro, $this->db_filtro_datos, $offset, $cantidad, $this->db_agrupar );
		$this->db_mensaje = $conn->GetMensaje();
	}
	public function get_cantidad_cargados(){
		return count($this->db_filas);
	}
	public function get_cantidad(){
		return $this->db_cantidad;
	}
	
	public function get_multiprecio_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["multiprecio_id"];
			return $val;
		}
		return 0;
	}
	public function get_producto_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["producto_id"];
			return $val;
		}
		return "";
	}
	public function get_nombre($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["nombre"];
			return $val;
		}
		return "";
	}
	public function get_precio($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["precio"];
			return $val;
		}
		return "";
	}
};
?>		
